JavaScript Data GridConfiguration options

Configure your grid down to each column, row, and cell, using various built-in options that control Handsontable's behavior and user interface.

Overview

To apply configuration options, pass them as a second argument of the Handsontable constructor, using the object literal notation:

import Handsontable from 'handsontable';
import 'handsontable/styles/handsontable.css';
import 'handsontable/styles/ht-theme-main.css';

const container = document.querySelector('#example');
const hot = new Handsontable(container, {
  // configuration options, in the object literal notation
  licenseKey: "non-commercial-and-evaluation",
  data: [
    ['A1', 'B1', 'C1', 'D1'],
    ['A2', 'B2', 'C2', 'D2'],
    ['A3', 'B3', 'C3', 'D3'],
  ],
  width: 400,
  height: 300,
  colHeaders: true,
  rowHeaders: true,
  customBorders: true,
  dropdownMenu: true,
  multiColumnSorting: true,
  filters: true,
  manualRowMove: true,
});

Depending on your needs, you can apply configuration options to different elements of your grid, such as:

For the full list of available configuration options, see the configuration options' API reference.

Cascading configuration

Handsontable's configuration cascades down:

When you modify the mid-level column options (using the columns option):

  • The options that you change overwrite the top-level grid options.
  • The options that you change cascade down to the bottom-level cell options.
  • Any unchanged options are inherited from the top-level grid options.

When you modify the bottom-level cell options (using the cell option):

  • The options that you change overwrite the top-level grid options.
  • The options that you change overwrite the mid-level column options.
  • Any unchanged options are inherited from the mid-level column options or the top-level grid options.

When you modify any options with the cells function, the changes overwrite all other options.

TIP

The cells option is a function invoked before Handsontable's rendering cycle. Implemented incorrectly, it can slow Handsontable down. Use the cells option only if the cell option, the columns option, and the setCellMeta() method don't meet your needs.

For more details on Handsontable's cascading configuration, see the MetaManager class (opens new window).

Plugin options

Configuration options can come from:

If you use Handsontable through modules: to use an option that comes from a Handsontable plugin, you need to import and register that plugin when initializing your Handsontable instance.

To find out if an option comes from a plugin, check the Category label in the configuration options' API reference.

Set grid options

To apply configuration options to the entire grid, pass your options as a second argument of the Handsontable constructor, using the object literal notation.

For example, to set the entire grid's width and height:

const hot = new Handsontable(container, {
  // top-level grid options that apply to the entire grid
  width: 400,
  height: 300
});

Example

To configure each cell in the grid as read-only, apply the readOnly option as a top-level grid option.

The top-level grid options cascade down:

  • To the mid-level column options
  • To the bottom-level cell options

As a result, each cell in the grid is read-only:

    Set column options

    To apply configuration options to an individual column (or a range of columns), use the columns option.

    const hot = new Handsontable(container, {
      columns: [
        {},
        {},
        // column options, apply to each cell of the third (by physical index) column
        {
          readOnly: true,
        },
      ],
    });
    

    Example

    In the example below, the columns option is set to a function.

    The function applies the readOnly: true option to each column that has a physical index of either 2 or 8.

    The modified mid-level column options:

    • Overwrite the top-level grid options
    • Cascade down to the bottom-level cell options

    As a result, each cell in the third and ninth columns is read-only:

      Set row options

      To apply configuration options to an individual row (or a range of rows), use the cells option.

      Any options modified through cells overwrite all other options.

      The function can take three arguments:

      • row: a row coordinate (a physical index)
      • col: a column coordinate (a physical index)
      • prop: if your data is an array of objects, prop is a property name for a column's data source object.
        If your data is an array of arrays, prop is the same as col.
      const hot = new Handsontable(container, {
        // the `cells` options overwrite all other options
        cells(row, col, prop) {
          if (row === 1 || row === 4) {
            return {
              // row options, which apply to each cell of the second row
              // and to each cell of the fifth row
              readOnly: true,
            };
          }
        }
      });
      

      Example

      In the example below, the cells option sets each cell in the first and fourth row as readOnly.

      Options modified through cells overwrite all other options.

        Set cell options

        To apply configuration options to individual cells, use the cell option.

        const hot = new Handsontable(container, {
          cell: [
            {
              // cell options, apply only to a cell with coordinates (0, 0)
              row: 0,
              col: 0,
              readOnly: true,
            },
            {
              // cell options, apply only to a cell with coordinates (1, 1)
              row: 1,
              col: 1,
              readOnly: true,
            }
          ],
          autoWrapRow: true,
          autoWrapCol: true,
        });
        

        Example

        In the example below, the cell option sets cell A1(0, 0) and cell B2(1, 1) as readOnly.

        The modified cell options:

        • Overwrite the top-level grid options
        • Overwrite mid-level column options

          Read cell options

          When Handsontable is running, you can check a cell's current options, using the getCellMeta() method.

          The getCellMeta() method returns an object with:

          For example:

          import Handsontable from 'handsontable';
          import 'handsontable/styles/handsontable.css';
          import 'handsontable/styles/ht-theme-main.css';
          
          const container = document.querySelector('#example');
          const hot = new Handsontable(container, {
            // top-level grid options that apply to the entire grid
            data: [
              ['A1', 'B1', 'C1', 'D1'],
              ['A2', 'B2', 'C2', 'D2'],
              ['A3', 'B3', 'C3', 'D3'],
            ],
            licenseKey: 'non-commercial-and-evaluation',
            width: 'auto',
            height: 'auto',
            rowHeaders: true,
            colHeaders: true,
            // in the top-level grid options, all cells are read-only
            readOnly: false,
            cell: [
              {
                // bottom-level cell options overwrite the top-level grid options
                // apply only to a cell with coordinates (1, 1)
                row: 1,
                col: 1,
                readOnly: true,
              }
            ]
          });
          
          // for cell (0, 0), the `readOnly` option is the default (`false`)
          // returns `false`
          hot.getCellMeta(0, 0).readOnly;
          
          // for cell (1, 1), the `cell` option overwrote the default `readOnly` value
          // returns `true`
          hot.getCellMeta(1, 1).readOnly;
          

          Change cell options

          When Handsontable is running, you can change the initial cell options, using the setCellMeta() method.

          For example:

          import Handsontable from 'handsontable';
          import 'handsontable/styles/handsontable.css';
          import 'handsontable/styles/ht-theme-main.css';
          
          const container = document.querySelector('#example');
          const hot = new Handsontable(container, {
            // top-level grid options that apply to the entire grid
            data: [
              ['A1', 'B1', 'C1', 'D1'],
              ['A2', 'B2', 'C2', 'D2'],
              ['A3', 'B3', 'C3', 'D3'],
            ],
            licenseKey: 'non-commercial-and-evaluation',
            width: 'auto',
            height: 'auto',
            rowHeaders: true,
            colHeaders: true,
          });
          
          // changes the `readOnly` option of cell (1, 1) back to `false`
          hot.setCellMeta(1, 1, 'readOnly', false);
          
          // returns `false`
          hot.getCellMeta(1, 1).readOnly;
          

          Implement custom logic

          You can apply configuration options to individual grid elements (columns, rows, cells), based on any logic you implement, using the cells option.

          The cells option overwrites all other options.

          The function can take three arguments:

          • row: a row coordinate (a physical index)
          • col: a column coordinate (a physical index)
          • prop: if your data is an array of objects, prop is a property name for a column's data source object.
            If your data is an array of arrays, prop is the same as col.
          const hot = new Handsontable(container, {
            cells(row, col) {
              if ((row === 1 || row === 5) && col === 1) {
                return {
                  readOnly: true,
                };
              }
            }
          });
          

          Example

          In the example below, the modified cells options overwrite the top-level grid options.

            Configuration example

            In the example below, some cells are read-only, and some cells are editable:

            • By default, all cells are read-only (as set in the top-level grid options).
            • For the first column, the mid-level column options overwrite the top-level grid options.
              As a result, the first column cells are editable.
            • For cell A1 (0, 0), the bottom-level cell options overwrite both the mid-level column options, and the top-level grid options.
              As a result, cell A1 (0, 0) is read-only, despite being part of the editable first column.
            • For cell C3 (3, 3), the cells option overwrites all other options.
              As a result, cell C3 (3, 3) is editable, despite not being part of the editable first column.

Angular Data GridConfiguration options

Configure your grid down to each column, row, and cell, using various built-in options that control Handsontable's behavior and user interface.

Overview

To apply configuration options, pass them as GridSettings object to HotTableComponent.

import { GridSettings } from "@handsontable/angular-wrapper";

data = [
  ["A1", "B1", "C1", "D1"],
  ["A2", "B2", "C2", "D2"],
  ["A3", "B3", "C3", "D3"],
];
gridSettings: GridSettings = {
  autoWrapRow: true,
  autoWrapCol: true,
  width: 400,
  height: 300,
  colHeaders: true,
  rowHeaders: true,
  customBorders: true,
  dropdownMenu: true,
  multiColumnSorting: true,
  filters: true,
  manualRowMove: true,
};
<hot-table [data]="data" [settings]="gridSettings" />

Depending on your needs, you can apply configuration options to different elements of your grid, such as:

For the full list of available configuration options, see the configuration options' API reference.

Cascading configuration

Handsontable's configuration cascades down:

When you modify the mid-level column options (using the columns option):

  • The options that you change overwrite the top-level grid options.
  • The options that you change cascade down to the bottom-level cell options.
  • Any unchanged options are inherited from the top-level grid options.

When you modify the bottom-level cell options (using the cell option):

  • The options that you change overwrite the top-level grid options.
  • The options that you change overwrite the mid-level column options.
  • Any unchanged options are inherited from the mid-level column options or the top-level grid options.

When you modify any options with the cells function, the changes overwrite all other options.

TIP

The cells option is a function invoked before Handsontable's rendering cycle. Implemented incorrectly, it can slow Handsontable down. Use the cells option only if the cell option, the columns option, and the setCellMeta() method don't meet your needs.

For more details on Handsontable's cascading configuration, see the MetaManager class (opens new window).

Plugin options

Configuration options can come from:

If you use Handsontable through modules: to use an option that comes from a Handsontable plugin, you need to import and register that plugin when initializing your Handsontable instance.

To find out if an option comes from a plugin, check the Category label in the configuration options' API reference.

Set grid options

To apply configuration options to the entire grid, pass your options as GridSettings object to HotTableComponent.

For example, to set the entire grid's width and height:

import { GridSettings } from "@handsontable/angular-wrapper";

gridSettings: GridSettings = {
  width: 400,
  height: 300,
};
<hot-table [settings]="gridSettings" />

Example

To configure each cell in the grid as read-only, apply the readOnly option as a top-level grid option.

The top-level grid options cascade down:

  • To the mid-level column options
  • To the bottom-level cell options

As a result, each cell in the grid is read-only:

/* file: app.component.ts */
import { Component } from '@angular/core';
import { GridSettings } from '@handsontable/angular-wrapper';
import Handsontable from 'handsontable';

@Component({
  selector: 'example1-configuration-options',
  standalone: false,
  template: ` <div>
    <hot-table [data]="data" [settings]="gridSettings"></hot-table>
  </div>`,
})
export class Example1ConfigurationOptionsComponent {

  readonly data: Handsontable.CellValue[][] = [
    ['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1', 'I1', 'J1'],
    ['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2', 'H2', 'I2', 'J2'],
    ['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3', 'H3', 'I3', 'J3'],
    ['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4', 'H4', 'I4', 'J4'],
    ['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5', 'H5', 'I5', 'J5'],
  ];

  readonly gridSettings: GridSettings = {
    autoWrapRow: true,
    autoWrapCol: true,
    readOnly: true,
    width: 'auto',
    height: 'auto',
    rowHeaders: true,
    colHeaders: true
  };
}



/* file: app.module.ts */
import { NgModule, ApplicationConfig } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, HotTableModule } from '@handsontable/angular-wrapper';
import { CommonModule } from '@angular/common';
import { NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
import { Example1ConfigurationOptionsComponent } from './app.component';

// register Handsontable's modules
registerAllModules();

export const appConfig: ApplicationConfig = {
  providers: [
    {
      provide: HOT_GLOBAL_CONFIG,
      useValue: {
        themeName: 'ht-theme-main',
        license: NON_COMMERCIAL_LICENSE,
      } as HotGlobalConfig
    }
  ],
};

@NgModule({
  imports: [ BrowserModule, HotTableModule, CommonModule ],
  declarations: [ Example1ConfigurationOptionsComponent ],
  providers: [...appConfig.providers],
  bootstrap: [ Example1ConfigurationOptionsComponent ]
})

export class AppModule { }

Set column options

To apply configuration options to an individual column (or a range of columns), use the columns option.

import { GridSettings } from "@handsontable/angular-wrapper";

gridSettings: GridSettings = {
  columns: [
    { width: 100 }, // column options for the first (by physical index) column
    { width: 100 }, // column options for the second (by physical index) column
    { width: 100 }, // column options for the third (by physical index) column
  ],
};
<hot-table [settings]="gridSettings" />

Example

In the example below, the columns option is set to a function.

The function applies the readOnly: true option to each column that has a physical index of either 2 or 8.

The modified mid-level column options:

  • Overwrite the top-level grid options
  • Cascade down to the bottom-level cell options

As a result, each cell in the third and ninth columns is read-only:

/* file: app.component.ts */
import { Component } from '@angular/core';
import { GridSettings } from '@handsontable/angular-wrapper';
import Handsontable from 'handsontable';

@Component({
  selector: 'example2-configuration-options',
  standalone: false,
  template: ` <div>
    <hot-table [data]="data" [settings]="gridSettings"></hot-table>
  </div>`,
})
export class Example2ConfigurationOptionsComponent {

  readonly data: Handsontable.CellValue[][] = [
    ['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1', 'I1', 'J1'],
    ['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2', 'H2', 'I2', 'J2'],
    ['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3', 'H3', 'I3', 'J3'],
    ['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4', 'H4', 'I4', 'J4'],
    ['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5', 'H5', 'I5', 'J5'],
  ];

  readonly gridSettings: GridSettings = {
    autoWrapRow: true,
    autoWrapCol: true,
    readOnly: false,
    width: 'auto',
    height: 'auto',
    rowHeaders: true,
    colHeaders: true,
    columns: (index: number) => ({
      type: index > 0 ? 'numeric' : 'text',
      readOnly: index === 2 || index === 8,
    })
  };
}



/* file: app.module.ts */
import { NgModule, ApplicationConfig } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, HotTableModule } from '@handsontable/angular-wrapper';
import { CommonModule } from '@angular/common';
import { NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
import { Example2ConfigurationOptionsComponent } from './app.component';

// register Handsontable's modules
registerAllModules();

export const appConfig: ApplicationConfig = {
  providers: [
    {
      provide: HOT_GLOBAL_CONFIG,
      useValue: {
        themeName: 'ht-theme-main',
        license: NON_COMMERCIAL_LICENSE,
      } as HotGlobalConfig
    }
  ],
};

@NgModule({
  imports: [ BrowserModule, HotTableModule, CommonModule ],
  declarations: [ Example2ConfigurationOptionsComponent ],
  providers: [...appConfig.providers],
  bootstrap: [ Example2ConfigurationOptionsComponent ]
})

export class AppModule { }

Set row options

To apply configuration options to an individual row (or a range of rows), use the cells option.

Any options modified through cells overwrite all other options.

The function can take three arguments:

  • row: a row coordinate (a physical index)
  • col: a column coordinate (a physical index)
  • prop: if your data is an array of objects, prop is a property name for a column's data source object.
    If your data is an array of arrays, prop is the same as col.
import { GridSettings } from "@handsontable/angular-wrapper";

gridSettings: GridSettings = {
  cells: (row, col, prop) => {
    if (row === 1 || row === 4) {
      return {
        // row options, which apply to each cell of the second row
        // and to each cell of the fifth row
        readOnly: true,
      };
    }
  },
};
<hot-table [settings]="gridSettings" />

Example

In the example below, the cells option sets each cell in the first and fourth row as readOnly.

Options modified through cells overwrite all other options.

/* file: app.component.ts */
import { Component } from '@angular/core';
import { GridSettings } from '@handsontable/angular-wrapper';
import Handsontable from 'handsontable';

@Component({
  selector: 'example3-configuration-options',
  standalone: false,
  template: ` <div>
    <hot-table [data]="data" [settings]="gridSettings"></hot-table>
  </div>`,
})
export class Example3ConfigurationOptionsComponent {

  readonly data: Handsontable.CellValue[][] = [
    ['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1', 'I1', 'J1'],
    ['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2', 'H2', 'I2', 'J2'],
    ['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3', 'H3', 'I3', 'J3'],
    ['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4', 'H4', 'I4', 'J4'],
    ['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5', 'H5', 'I5', 'J5'],
  ];

  readonly gridSettings: GridSettings = {
    autoWrapRow: true,
    autoWrapCol: true,
    readOnly: false,
    width: 'auto',
    height: 'auto',
    rowHeaders: true,
    colHeaders: true,
    cells: (row: number, col: number) => {
      if (row === 1 || row === 4) {
        return { readOnly: true };
      }

      return {};
    }
  };
}



/* file: app.module.ts */
import { NgModule, ApplicationConfig } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, HotTableModule } from '@handsontable/angular-wrapper';
import { CommonModule } from '@angular/common';
import { NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
import { Example3ConfigurationOptionsComponent } from './app.component';

// register Handsontable's modules
registerAllModules();

export const appConfig: ApplicationConfig = {
  providers: [
    {
      provide: HOT_GLOBAL_CONFIG,
      useValue: {
        themeName: 'ht-theme-main',
        license: NON_COMMERCIAL_LICENSE,
      } as HotGlobalConfig
    }
  ],
};

@NgModule({
  imports: [ BrowserModule, HotTableModule, CommonModule ],
  declarations: [ Example3ConfigurationOptionsComponent ],
  providers: [...appConfig.providers],
  bootstrap: [ Example3ConfigurationOptionsComponent ]
})

export class AppModule { }

Set cell options

To apply configuration options to individual cells, use the cell option.

import { GridSettings } from "@handsontable/angular-wrapper";

gridSettings: GridSettings = {
  cell: [
    {
      // bottom-level cell options overwrite the top-level grid options
      // apply only to a cell with coordinates (0, 0)
      row: 0,
      col: 0,
    },
    {
      // bottom-level cell options overwrite the top-level grid options
      // apply only to a cell with coordinates (1, 1)
      row: 1,
      col: 1,
    },
  ],
};
<hot-table [settings]="gridSettings" />

Example

In the example below, the cell option sets cell A1(0, 0) and cell B2(1, 1) as readOnly.

The modified cell options:

  • Overwrite the top-level grid options
  • Overwrite mid-level column options

/* file: app.component.ts */
import { Component } from '@angular/core';
import { GridSettings } from '@handsontable/angular-wrapper';
import Handsontable from 'handsontable';

@Component({
  selector: 'example4-configuration-options',
  standalone: false,
  template: ` <div>
    <hot-table [data]="data" [settings]="gridSettings"></hot-table>
  </div>`,
})
export class Example4ConfigurationOptionsComponent {

  readonly data: Handsontable.CellValue[][] = [
    ['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1', 'I1', 'J1'],
    ['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2', 'H2', 'I2', 'J2'],
    ['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3', 'H3', 'I3', 'J3'],
    ['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4', 'H4', 'I4', 'J4'],
    ['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5', 'H5', 'I5', 'J5'],
  ];

  readonly gridSettings: GridSettings = {
    autoWrapRow: true,
    autoWrapCol: true,
    readOnly: false,
    width: 'auto',
    height: 'auto',
    rowHeaders: true,
    colHeaders: true,
    cell: [
      {
        // bottom-level cell options overwrite the top-level grid options
        // apply only to a cell with coordinates (0, 0)
        row: 0,
        col: 0,
        readOnly: true,
      },
      {
        // bottom-level cell options overwrite the top-level grid options
        // apply only to a cell with coordinates (1, 1)
        row: 1,
        col: 1,
        readOnly: true,
      },
    ]
  };
}



/* file: app.module.ts */
import { NgModule, ApplicationConfig } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, HotTableModule } from '@handsontable/angular-wrapper';
import { CommonModule } from '@angular/common';
import { NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
import { Example4ConfigurationOptionsComponent } from './app.component';

// register Handsontable's modules
registerAllModules();

export const appConfig: ApplicationConfig = {
  providers: [
    {
      provide: HOT_GLOBAL_CONFIG,
      useValue: {
        themeName: 'ht-theme-main',
        license: NON_COMMERCIAL_LICENSE,
      } as HotGlobalConfig
    }
  ],
};

@NgModule({
  imports: [ BrowserModule, HotTableModule, CommonModule ],
  declarations: [ Example4ConfigurationOptionsComponent ],
  providers: [...appConfig.providers],
  bootstrap: [ Example4ConfigurationOptionsComponent ]
})

export class AppModule { }

Read cell options

When Handsontable is running, you can check a cell's current options, using the getCellMeta() method.

The getCellMeta() method returns an object with:

For example:

@ViewChild(HotTableComponent, { static: false }) readonly hotTable!: HotTableComponent;

import { GridSettings } from "@handsontable/angular-wrapper";

// Consider the HotTable component with the `cell` option declared:
gridSettings: GridSettings = {
  cell: [
    {
      row: 1,
      col: 1,
      readOnly: true,
    },
  ]
};

// for cell (0, 0), the `readOnly` option is the default (`false`)
// returns `false`
hotTable.hotInstance.getCellMeta(0, 0).readOnly;

// for cell (1, 1), the `cell` option overwrote the default `readOnly` value
// returns `true`
hotTable.hotInstance.getCellMeta(1, 1).readOnly;
<hot-table [settings]="gridSettings" />

Change cell options

When Handsontable is running, you can change the initial cell options, using the setCellMeta() method.

For example:

@ViewChild(HotTableComponent, { static: false }) readonly hotTable!: HotTableComponent;

import { GridSettings } from "@handsontable/angular-wrapper";

// Consider the HotTable component with the `cell` option declared:
gridSettings: GridSettings = {
  cell: [
    {
      row: 1,
      col: 1,
      readOnly: true,
    },
  ]
};

// changes the `readOnly` option of cell (1, 1) back to `false`
hotTable.hotInstance.setCellMeta(1, 1, "readOnly", false);

// returns `false`
hotTable.hotInstance.getCellMeta(1, 1).readOnly;
<hot-table [settings]="gridSettings" />

Implement custom logic

You can apply configuration options to individual grid elements (columns, rows, cells), based on any logic you implement, using the cells option.

The cells option overwrites all other options.

The function can take three arguments:

  • row: a row coordinate (a physical index)
  • col: a column coordinate (a physical index)
  • prop: if your data is an array of objects, prop is a property name for a column's data source object.
    If your data is an array of arrays, prop is the same as col.
import { GridSettings } from "@handsontable/angular-wrapper";

gridSettings: GridSettings = {
  cells: (row, col) => {
    if ((row === 1 || row === 5) && col === 1) {
      return {
        readOnly: true,
      };
    }
  },
};
<hot-table [settings]="gridSettings" />

Example

In the example below, the modified cells options overwrite the top-level grid options.

// for cell (0, 0), the `readOnly` option is the default (`false`)
// returns `false`
hot.getCellMeta(0, 0).readOnly;

// for cell (1, 1), the `cell` option overwrote the default `readOnly` value
// returns `true`
hot.getCellMeta(1, 1).readOnly;

// changes the `readOnly` option of cell (1, 1) back to `false`
hot.setCellMeta(1, 1, 'readOnly', false);

// returns `false`
hot.getCellMeta(1, 1).readOnly;

Configuration example

In the example below, some cells are read-only, and some cells are editable:

  • By default, all cells are read-only (as set in the top-level grid options).
  • For the first column, the mid-level column options overwrite the top-level grid options.
    As a result, the first column cells are editable.
  • For cell A1 (0, 0), the bottom-level cell options overwrite both the mid-level column options, and the top-level grid options.
    As a result, cell A1 (0, 0) is read-only, despite being part of the editable first column.
  • For cell C3 (3, 3), the cells option overwrites all other options.
    As a result, cell C3 (3, 3) is editable, despite not being part of the editable first column.

/* file: app.component.ts */
import { Component } from '@angular/core';
import { GridSettings } from '@handsontable/angular-wrapper';
import Handsontable from 'handsontable';

@Component({
  selector: 'example6-configuration-options',
  standalone: false,
  template: ` <div>
    <hot-table [data]="data" [settings]="gridSettings"></hot-table>
  </div>`,
})
export class Example6ConfigurationOptionsComponent {

  readonly data: Handsontable.CellValue[][] = [
    ['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1', 'I1', 'J1'],
    ['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2', 'H2', 'I2', 'J2'],
    ['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3', 'H3', 'I3', 'J3'],
    ['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4', 'H4', 'I4', 'J4'],
    ['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5', 'H5', 'I5', 'J5'],
  ];

  readonly gridSettings: GridSettings = {
    autoWrapRow: true,
    autoWrapCol: true,
    readOnly: true,
    width: 'auto',
    height: 'auto',
    rowHeaders: true,
    colHeaders: true,
    columns: [
      // each cell in the first (by physical index) column is editable
      { readOnly: false, className: '' },
      {},
      {},
      {},
      {},
      {},
      {},
      {},
      {},
      {},
    ],
    cell: [
      // cell (0, 0) is read-only
      { row: 0, col: 0, readOnly: true },
    ],
    cells: (row: number, col: number) => {
      // cell (2, 2) is editable
      if (row === 2 && col === 2) {
        return { readOnly: false, className: '' };
      }

      return {};
    }
  };
}



/* file: app.module.ts */
import { NgModule, ApplicationConfig } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, HotTableModule } from '@handsontable/angular-wrapper';
import { CommonModule } from '@angular/common';
import { NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
import { Example6ConfigurationOptionsComponent } from './app.component';

// register Handsontable's modules
registerAllModules();

export const appConfig: ApplicationConfig = {
  providers: [
    {
      provide: HOT_GLOBAL_CONFIG,
      useValue: {
        themeName: 'ht-theme-main',
        license: NON_COMMERCIAL_LICENSE,
      } as HotGlobalConfig
    }
  ],
};

@NgModule({
  imports: [ BrowserModule, HotTableModule, CommonModule ],
  declarations: [ Example6ConfigurationOptionsComponent ],
  providers: [...appConfig.providers],
  bootstrap: [ Example6ConfigurationOptionsComponent ]
})

export class AppModule { }

Skip to content

Configure your grid down to each column, row, and cell, using various built-in options that control Handsontable’s behavior and user interface.

Overview

To apply configuration options in Vue 3, pass them inside a hotSettings ref bound to the HotTable component with the :settings prop:

<script setup>
import { ref } from 'vue';
import { HotTable } from '@handsontable/vue3';
import { registerAllModules } from 'handsontable/registry';
registerAllModules();
const hotSettings = ref({
licenseKey: 'non-commercial-and-evaluation',
data: [
['A1', 'B1', 'C1', 'D1'],
['A2', 'B2', 'C2', 'D2'],
['A3', 'B3', 'C3', 'D3'],
],
width: 400,
height: 300,
colHeaders: true,
rowHeaders: true,
customBorders: true,
dropdownMenu: true,
multiColumnSorting: true,
filters: true,
manualRowMove: true,
});
</script>
<template>
<HotTable :settings="hotSettings" />
</template>

Depending on your needs, you can apply configuration options to different elements of your grid, such as:

For the full list of available configuration options, see the configuration options’ API reference.

Cascading configuration

Handsontable’s configuration cascades down:

  • From the top-level grid options (GlobalMeta)
  • Through the mid-level column options (ColumnMeta)
  • To the bottom-level cell options (CellMeta)

When you modify the mid-level column options (using the columns option):

  • The options that you change overwrite the top-level grid options.
  • The options that you change cascade down to the bottom-level cell options.
  • Any unchanged options are inherited from the top-level grid options.

When you modify the bottom-level cell options (using the cell option):

  • The options that you change overwrite the top-level grid options.
  • The options that you change overwrite the mid-level column options.
  • Any unchanged options are inherited from the mid-level column options or the top-level grid options.

When you modify any options with the cells function, the changes overwrite all other options.

For more details on Handsontable’s cascading configuration, see the MetaManager class.

Plugin options

Configuration options come from:

If you use Handsontable through modules: to use an option that comes from a Handsontable plugin, you need to import and register that plugin when initializing your Handsontable instance.

To find out if an option comes from a plugin, check the Category label in the configuration options’ API reference.

Set grid options

For example, to set the entire grid’s width and height:

const hotSettings = ref({
// top-level grid options that apply to the entire grid
width: 400,
height: 300,
});
<HotTable :settings="hotSettings" />

Example

To configure each cell in the grid as read-only, apply the readOnly option as a top-level grid option.

The top-level grid options cascade down:

  • To the mid-level column options
  • To the bottom-level cell options

As a result, each cell in the grid is read-only:

Vue
<script setup lang="ts">
import { ref } from 'vue';
import { HotTable } from '@handsontable/vue3';
import { registerAllModules } from 'handsontable/registry';
import type { GridSettings } from 'handsontable/settings';
registerAllModules();
const hotSettings = ref<GridSettings>({
data: [
['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1', 'I1', 'J1'],
['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2', 'H2', 'I2', 'J2'],
['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3', 'H3', 'I3', 'J3'],
['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4', 'H4', 'I4', 'J4'],
['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5', 'H5', 'I5', 'J5'],
],
autoWrapRow: true,
autoWrapCol: true,
readOnly: true,
width: 'auto',
height: 'auto',
rowHeaders: true,
colHeaders: true,
licenseKey: 'non-commercial-and-evaluation',
});
</script>
<template>
<div id="example1">
<HotTable :settings="hotSettings" />
</div>
</template>

Set column options

To apply configuration options to an individual column (or a range of columns), use the columns option.

const hotSettings = ref({
columns: [
{ width: 100 }, // column options for the first (by physical index) column
{ width: 100 }, // column options for the second (by physical index) column
{ width: 100 }, // column options for the third (by physical index) column
],
});
<HotTable :settings="hotSettings" />

Example

In the example below, the columns option is set to a function.

The function applies the readOnly: true option to each column that has a physical index of either 2 or 8.

The modified mid-level column options:

  • Overwrite the top-level grid options
  • Cascade down to the bottom-level cell options

As a result, each cell in the third and ninth columns is read-only:

Vue
<script setup lang="ts">
import { ref } from 'vue';
import { HotTable } from '@handsontable/vue3';
import { registerAllModules } from 'handsontable/registry';
import type { GridSettings } from 'handsontable/settings';
registerAllModules();
const hotSettings = ref<GridSettings>({
data: [
['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1', 'I1', 'J1'],
['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2', 'H2', 'I2', 'J2'],
['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3', 'H3', 'I3', 'J3'],
['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4', 'H4', 'I4', 'J4'],
['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5', 'H5', 'I5', 'J5'],
],
autoWrapRow: true,
autoWrapCol: true,
width: 'auto',
height: 'auto',
rowHeaders: true,
colHeaders: true,
readOnly: false,
columns(index) {
return {
type: index > 0 ? 'numeric' : 'text',
readOnly: index === 2 || index === 8,
};
},
licenseKey: 'non-commercial-and-evaluation',
});
</script>
<template>
<div id="example2">
<HotTable :settings="hotSettings" />
</div>
</template>

Set row options

To apply configuration options to an individual row (or a range of rows), use the cells option.

Any options modified through cells overwrite all other options.

const hotSettings = ref({
cells(row, col, prop) {
if (row === 1 || row === 4) {
return {
// row options, which apply to each cell of the second row
// and to each cell of the fifth row
readOnly: true,
};
}
},
});
<HotTable :settings="hotSettings" />

Example

In the example below, the cells option sets each cell in the first and fourth row as readOnly.

Options modified through cells overwrite all other options.

Vue
<script setup lang="ts">
import { ref } from 'vue';
import { HotTable } from '@handsontable/vue3';
import { registerAllModules } from 'handsontable/registry';
import type { GridSettings } from 'handsontable/settings';
registerAllModules();
const hotSettings = ref<GridSettings>({
data: [
['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1', 'I1', 'J1'],
['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2', 'H2', 'I2', 'J2'],
['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3', 'H3', 'I3', 'J3'],
['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4', 'H4', 'I4', 'J4'],
['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5', 'H5', 'I5', 'J5'],
],
autoWrapRow: true,
autoWrapCol: true,
width: 'auto',
height: 'auto',
rowHeaders: true,
colHeaders: true,
cells(row) {
if (row === 1 || row === 4) {
return { readOnly: true };
}
return {};
},
licenseKey: 'non-commercial-and-evaluation',
});
</script>
<template>
<div id="example3">
<HotTable :settings="hotSettings" />
</div>
</template>

Set cell options

To apply configuration options to individual cells, use the cell option.

const hotSettings = ref({
cell: [
{
// cell options, apply only to a cell with coordinates (0, 0)
row: 0,
col: 0,
readOnly: true,
},
{
// cell options, apply only to a cell with coordinates (1, 1)
row: 1,
col: 1,
readOnly: true,
},
],
autoWrapRow: true,
autoWrapCol: true,
});
<HotTable :settings="hotSettings" />

Example

In the example below, the cell option sets cell A1(0, 0) and cell B2(1, 1) as readOnly.

The modified cell options:

  • Overwrite the top-level grid options
  • Overwrite mid-level column options
Vue
<script setup lang="ts">
import { ref } from 'vue';
import { HotTable } from '@handsontable/vue3';
import { registerAllModules } from 'handsontable/registry';
import type { GridSettings } from 'handsontable/settings';
registerAllModules();
const hotSettings = ref<GridSettings>({
data: [
['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1', 'I1', 'J1'],
['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2', 'H2', 'I2', 'J2'],
['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3', 'H3', 'I3', 'J3'],
['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4', 'H4', 'I4', 'J4'],
['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5', 'H5', 'I5', 'J5'],
],
autoWrapRow: true,
autoWrapCol: true,
readOnly: false,
width: 'auto',
height: 'auto',
rowHeaders: true,
colHeaders: true,
cell: [
{ row: 0, col: 0, readOnly: true },
{ row: 1, col: 1, readOnly: true },
],
licenseKey: 'non-commercial-and-evaluation',
});
</script>
<template>
<div id="example4">
<HotTable :settings="hotSettings" />
</div>
</template>

Read cell options

When Handsontable is running, you can check a cell’s current options, using the getCellMeta() method.

The getCellMeta() method returns an object with:

For example:

// Access the Handsontable instance via the template ref:
const hot = hotRef.value?.hotInstance;
// for cell (0, 0), the `readOnly` option is the default (`false`)
// returns `false`
hot?.getCellMeta(0, 0).readOnly;
// for cell (1, 1), the `cell` option overwrote the default `readOnly` value
// returns `true`
hot?.getCellMeta(1, 1).readOnly;

Change cell options

When Handsontable is running, you can change the initial cell options, using the setCellMeta() method.

For example:

const hot = hotRef.value?.hotInstance;
// changes the `readOnly` option of cell (1, 1) back to `false`
hot?.setCellMeta(1, 1, 'readOnly', false);
// returns `false`
hot?.getCellMeta(1, 1).readOnly;

Implement custom logic

You can apply configuration options to individual grid elements (columns, rows, cells), based on any logic you implement, using the cells option.

The cells option overwrites all other options.

const hotSettings = ref({
cells(row, col) {
if ((row === 1 || row === 5) && col === 1) {
return {
readOnly: true,
};
}
},
});
<HotTable :settings="hotSettings" />

Example

In the example below, the modified cells options overwrite the top-level grid options.

const hot = hotRef.value?.hotInstance;
// for cell (0, 0), the `readOnly` option is the default (`false`)
// returns `false`
hot?.getCellMeta(0, 0).readOnly;
// for cell (1, 1), the `cell` option overwrote the default `readOnly` value
// returns `true`
hot?.getCellMeta(1, 1).readOnly;
// changes the `readOnly` option of cell (1, 1) back to `false`
hot?.setCellMeta(1, 1, 'readOnly', false);
// returns `false`
hot?.getCellMeta(1, 1).readOnly;

Configuration example

In the example below, some cells are read-only, and some cells are editable:

  • By default, all cells are read-only (as set in the top-level grid options).
  • For the first column, the mid-level column options overwrite the top-level grid options.
    As a result, the first column cells are editable.
  • For cell A1 (0, 0), the bottom-level cell options overwrite both the mid-level column options, and the top-level grid options.
    As a result, cell A1 (0, 0) is read-only, despite being part of the editable first column.
  • For cell C3 (3, 3), the cells option overwrites all other options.
    As a result, cell C3 (3, 3) is editable, despite not being part of the editable first column.
Vue
<script setup lang="ts">
import { ref } from 'vue';
import { HotTable } from '@handsontable/vue3';
import { registerAllModules } from 'handsontable/registry';
import type { GridSettings } from 'handsontable/settings';
registerAllModules();
const hotSettings = ref<GridSettings>({
data: [
['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1', 'I1', 'J1'],
['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2', 'H2', 'I2', 'J2'],
['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3', 'H3', 'I3', 'J3'],
['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4', 'H4', 'I4', 'J4'],
['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5', 'H5', 'I5', 'J5'],
],
autoWrapRow: true,
autoWrapCol: true,
readOnly: true,
width: 'auto',
height: 'auto',
rowHeaders: true,
colHeaders: true,
columns: [
{ readOnly: false, className: '' },
{},
{},
{},
{},
{},
{},
{},
{},
{},
],
cell: [
{ row: 0, col: 0, readOnly: true },
],
cells(row, col) {
if (row === 2 && col === 2) {
return { readOnly: false, className: '' };
}
return {};
},
licenseKey: 'non-commercial-and-evaluation',
});
</script>
<template>
<div id="example6">
<HotTable :settings="hotSettings" />
</div>
</template>

Configuration options

Core methods

Hooks

Result

Your grid now applies configuration options at the scope you specified — grid-wide, per column, per row, or per individual cell — using Handsontable’s cascading configuration system.

Skip to content

Configure your grid down to each column, row, and cell, using various built-in options that control Handsontable’s behavior and user interface.

Overview

To apply configuration options, pass them as individual props of the HotTable or HotColumn components.

<HotTable
autoWrapRow={true}
autoWrapCol={true}
licenseKey="non-commercial-and-evaluation"
data={[
['A1', 'B1', 'C1', 'D1'],
['A2', 'B2', 'C2', 'D2'],
['A3', 'B3', 'C3', 'D3'],
]}
width={400}
height={300}
colHeaders={true}
rowHeaders={true}
customBorders={true}
dropdownMenu={true}
multiColumnSorting={true}
filters={true}
manualRowMove={true}
/>

Depending on your needs, you can apply configuration options to different elements of your grid, such as:

For the full list of available configuration options, see the configuration options’ API reference.

Cascading configuration

Handsontable’s configuration cascades down:

  • From the top-level grid options (GlobalMeta)
  • Through the mid-level column options (ColumnMeta)
  • To the bottom-level cell options (CellMeta)

When you modify the mid-level column options (using the columns option):

  • The options that you change overwrite the top-level grid options.
  • The options that you change cascade down to the bottom-level cell options.
  • Any unchanged options are inherited from the top-level grid options.

When you modify the bottom-level cell options (using the cell option):

  • The options that you change overwrite the top-level grid options.
  • The options that you change overwrite the mid-level column options.
  • Any unchanged options are inherited from the mid-level column options or the top-level grid options.

When you modify any options with the cells function, the changes overwrite all other options.

For more details on Handsontable’s cascading configuration, see the MetaManager class.

Plugin options

Configuration options come from:

If you use Handsontable through modules: to use an option that comes from a Handsontable plugin, you need to import and register that plugin when initializing your Handsontable instance.

To find out if an option comes from a plugin, check the Category label in the configuration options’ API reference.

Set grid options

To apply configuration options to the entire grid, pass your options as individual props of the HotTable or HotColumn components.

For example, to set the entire grid’s width and height:

<HotTable width={400} height={300} />

Example

To configure each cell in the grid as read-only, apply the readOnly option as a top-level grid option.

The top-level grid options cascade down:

  • To the mid-level column options
  • To the bottom-level cell options

As a result, each cell in the grid is read-only:

JavaScript
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
// register Handsontable's modules
registerAllModules();
const ExampleComponent = () => {
const data = [
['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1', 'I1', 'J1'],
['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2', 'H2', 'I2', 'J2'],
['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3', 'H3', 'I3', 'J3'],
['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4', 'H4', 'I4', 'J4'],
['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5', 'H5', 'I5', 'J5'],
];
return (
<HotTable
autoWrapRow={true}
autoWrapCol={true}
licenseKey="non-commercial-and-evaluation"
data={data}
readOnly={true}
width="auto"
height="auto"
rowHeaders={true}
colHeaders={true}
/>
);
};
export default ExampleComponent;
TypeScript
import { FC } from 'react';
import { HotTable, HotTableProps } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import Handsontable from 'handsontable/base';
// register Handsontable's modules
registerAllModules();
const ExampleComponent: FC = () => {
const data: Handsontable.CellValue[][] = [
['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1', 'I1', 'J1'],
['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2', 'H2', 'I2', 'J2'],
['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3', 'H3', 'I3', 'J3'],
['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4', 'H4', 'I4', 'J4'],
['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5', 'H5', 'I5', 'J5'],
];
return (
<HotTable
autoWrapRow={true}
autoWrapCol={true}
licenseKey="non-commercial-and-evaluation"
data={data}
readOnly={true}
width="auto"
height="auto"
rowHeaders={true}
colHeaders={true}
/>
);
};
export default ExampleComponent;

Set column options

To apply configuration options to an individual column (or a range of columns), use the columns option.

<HotTable
columns={[
{width: 100}, // column options for the first (by physical index) column
{width: 100}, // column options for the second (by physical index) column
{width: 100}, // column options for the third (by physical index) column
]}
/>

Alternatively, you can use the HotColumn component to configure columns declaratively:

<HotTable>
<HotColumn width={100}/>
<HotColumn width={100}/>
<HotColumn width={100}/>
</HotTable>

Example

In the example below, the columns option is set to a function.

The function applies the readOnly: true option to each column that has a physical index of either 2 or 8.

The modified mid-level column options:

  • Overwrite the top-level grid options
  • Cascade down to the bottom-level cell options

As a result, each cell in the third and ninth columns is read-only:

JavaScript
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
// register Handsontable's modules
registerAllModules();
const ExampleComponent = () => {
const data = [
['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1', 'I1', 'J1'],
['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2', 'H2', 'I2', 'J2'],
['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3', 'H3', 'I3', 'J3'],
['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4', 'H4', 'I4', 'J4'],
['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5', 'H5', 'I5', 'J5'],
];
return (
<HotTable
autoWrapRow={true}
autoWrapCol={true}
licenseKey="non-commercial-and-evaluation"
data={data}
width="auto"
height="auto"
rowHeaders={true}
colHeaders={true}
readOnly={false}
columns={(index) => ({
type: index > 0 ? 'numeric' : 'text',
readOnly: index === 2 || index === 8,
})}
/>
);
};
export default ExampleComponent;
TypeScript
import { FC } from 'react';
import { HotTable, HotTableProps } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import Handsontable from 'handsontable/base';
// register Handsontable's modules
registerAllModules();
const ExampleComponent: FC = () => {
const data: Handsontable.CellValue[][] = [
['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1', 'I1', 'J1'],
['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2', 'H2', 'I2', 'J2'],
['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3', 'H3', 'I3', 'J3'],
['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4', 'H4', 'I4', 'J4'],
['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5', 'H5', 'I5', 'J5'],
];
return (
<HotTable
autoWrapRow={true}
autoWrapCol={true}
licenseKey="non-commercial-and-evaluation"
data={data}
width="auto"
height="auto"
rowHeaders={true}
colHeaders={true}
readOnly={false}
columns={(index: number) => ({
type: index > 0 ? 'numeric' : 'text',
readOnly: index === 2 || index === 8,
})}
/>
);
};
export default ExampleComponent;

Set row options

To apply configuration options to an individual row (or a range of rows), use the cells option.

Any options modified through cells overwrite all other options.

The function can take three arguments:

  • row: a row coordinate (a physical index)
  • col: a column coordinate (a physical index)
  • prop: if your data is an array of objects, prop is a property name for a column’s data source object.
    If your data is an array of arrays, prop is the same as col.
<HotTable cells={(row, col, prop) => {
if (row === 1 || row === 4) {
return {
// row options, which apply to each cell of the second row
// and to each cell of the fifth row
readOnly: true,
};
}
}}/>

Example

In the example below, the cells option sets each cell in the first and fourth row as readOnly.

Options modified through cells overwrite all other options.

JavaScript
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
// register Handsontable's modules
registerAllModules();
const ExampleComponent = () => {
const data = [
['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1', 'I1', 'J1'],
['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2', 'H2', 'I2', 'J2'],
['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3', 'H3', 'I3', 'J3'],
['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4', 'H4', 'I4', 'J4'],
['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5', 'H5', 'I5', 'J5'],
];
return (
<HotTable
autoWrapRow={true}
autoWrapCol={true}
licenseKey="non-commercial-and-evaluation"
data={data}
width="auto"
height="auto"
rowHeaders={true}
colHeaders={true}
cells={(row, col) => {
if (row === 1 || row === 4) {
return { readOnly: true };
}
return {};
}}
/>
);
};
export default ExampleComponent;
TypeScript
import { FC } from 'react';
import { HotTable, HotTableProps } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import Handsontable from 'handsontable/base';
// register Handsontable's modules
registerAllModules();
const ExampleComponent: FC = () => {
const data: Handsontable.CellValue[][] = [
['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1', 'I1', 'J1'],
['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2', 'H2', 'I2', 'J2'],
['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3', 'H3', 'I3', 'J3'],
['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4', 'H4', 'I4', 'J4'],
['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5', 'H5', 'I5', 'J5'],
];
return (
<HotTable
autoWrapRow={true}
autoWrapCol={true}
licenseKey="non-commercial-and-evaluation"
data={data}
width="auto"
height="auto"
rowHeaders={true}
colHeaders={true}
cells={(row: number, col: number) => {
if (row === 1 || row === 4) {
return { readOnly: true };
}
return {};
}}
/>
);
};
export default ExampleComponent;

Set cell options

To apply configuration options to individual cells, use the cell option.

<HotTable cell={[
{ // bottom-level cell options overwrite the top-level grid options
// apply only to a cell with coordinates (0, 0)
row: 0,
col: 0,
},
{
// bottom-level cell options overwrite the top-level grid options
// apply only to a cell with coordinates (1, 1)
row: 1,
col: 1,
}
]}/>

Example

In the example below, the cell option sets cell A1(0, 0) and cell B2(1, 1) as readOnly.

The modified cell options:

  • Overwrite the top-level grid options
  • Overwrite mid-level column options
JavaScript
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
// register Handsontable's modules
registerAllModules();
const ExampleComponent = () => {
const data = [
['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1', 'I1', 'J1'],
['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2', 'H2', 'I2', 'J2'],
['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3', 'H3', 'I3', 'J3'],
['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4', 'H4', 'I4', 'J4'],
['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5', 'H5', 'I5', 'J5'],
];
return (
<HotTable
data={data}
autoWrapRow={true}
autoWrapCol={true}
licenseKey="non-commercial-and-evaluation"
width="auto"
height="auto"
rowHeaders={true}
colHeaders={true}
readOnly={false}
cell={[
{
// bottom-level cell options overwrite the top-level grid options
// apply only to a cell with coordinates (0, 0)
row: 0,
col: 0,
readOnly: true,
},
{
// bottom-level cell options overwrite the top-level grid options
// apply only to a cell with coordinates (1, 1)
row: 1,
col: 1,
readOnly: true,
},
]}
/>
);
};
export default ExampleComponent;
TypeScript
import { FC } from 'react';
import { HotTable, HotTableProps } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import Handsontable from 'handsontable/base';
// register Handsontable's modules
registerAllModules();
const ExampleComponent: FC = () => {
const data: Handsontable.CellValue[][] = [
['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1', 'I1', 'J1'],
['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2', 'H2', 'I2', 'J2'],
['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3', 'H3', 'I3', 'J3'],
['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4', 'H4', 'I4', 'J4'],
['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5', 'H5', 'I5', 'J5'],
];
return (
<HotTable
data={data}
autoWrapRow={true}
autoWrapCol={true}
licenseKey="non-commercial-and-evaluation"
width="auto"
height="auto"
rowHeaders={true}
colHeaders={true}
readOnly={false}
cell={[
{
// bottom-level cell options overwrite the top-level grid options
// apply only to a cell with coordinates (0, 0)
row: 0,
col: 0,
readOnly: true,
},
{
// bottom-level cell options overwrite the top-level grid options
// apply only to a cell with coordinates (1, 1)
row: 1,
col: 1,
readOnly: true,
},
]}
/>
);
};
export default ExampleComponent;

Read cell options

When Handsontable is running, you can check a cell’s current options, using the getCellMeta() method.

The getCellMeta() method returns an object with:

For example:

// Consider the HotTable component with the `cell` option declared:
<HotTable
cell={[
{
row: 1,
col: 1,
readOnly: true,
}
]}
/>;
// for cell (0, 0), the `readOnly` option is the default (`false`)
// returns `false`
hot.getCellMeta(0, 0).readOnly;
// for cell (1, 1), the `cell` option overwrote the default `readOnly` value
// returns `true`
hot.getCellMeta(1, 1).readOnly;

Change cell options

When Handsontable is running, you can change the initial cell options, using the setCellMeta() method.

For example:

// changes the `readOnly` option of cell (1, 1) back to `false`
hot.setCellMeta(1, 1, 'readOnly', false);
// returns `false`
hot.getCellMeta(1, 1).readOnly;

Implement custom logic

You can apply configuration options to individual grid elements (columns, rows, cells), based on any logic you implement, using the cells option.

The cells option overwrites all other options.

The function can take three arguments:

  • row: a row coordinate (a physical index)
  • col: a column coordinate (a physical index)
  • prop: if your data is an array of objects, prop is a property name for a column’s data source object.
    If your data is an array of arrays, prop is the same as col.
<HotTable
cells={(row, col) => {
if ((row === 1 || row === 5) && col === 1) {
return {
readOnly: true,
};
}
}}
/>

Example

In the example below, the modified cells options overwrite the top-level grid options.

// for cell (0, 0), the `readOnly` option is the default (`false`)
// returns `false`
hot.getCellMeta(0, 0).readOnly;
// for cell (1, 1), the `cell` option overwrote the default `readOnly` value
// returns `true`
hot.getCellMeta(1, 1).readOnly;
// changes the `readOnly` option of cell (1, 1) back to `false`
hot.setCellMeta(1, 1, 'readOnly', false);
// returns `false`
hot.getCellMeta(1, 1).readOnly;

Configuration example

In the example below, some cells are read-only, and some cells are editable:

  • By default, all cells are read-only (as set in the top-level grid options).
  • For the first column, the mid-level column options overwrite the top-level grid options.
    As a result, the first column cells are editable.
  • For cell A1 (0, 0), the bottom-level cell options overwrite both the mid-level column options, and the top-level grid options.
    As a result, cell A1 (0, 0) is read-only, despite being part of the editable first column.
  • For cell C3 (3, 3), the cells option overwrites all other options.
    As a result, cell C3 (3, 3) is editable, despite not being part of the editable first column.
JavaScript
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
// register Handsontable's modules
registerAllModules();
const ExampleComponent = () => {
const data = [
['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1', 'I1', 'J1'],
['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2', 'H2', 'I2', 'J2'],
['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3', 'H3', 'I3', 'J3'],
['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4', 'H4', 'I4', 'J4'],
['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5', 'H5', 'I5', 'J5'],
];
return (
<HotTable
data={data}
autoWrapRow={true}
autoWrapCol={true}
licenseKey="non-commercial-and-evaluation"
readOnly={true}
width="auto"
height="auto"
rowHeaders={true}
colHeaders={true}
columns={[
// each cell in the first (by physical index) column is editable
{ readOnly: false, className: '' },
{},
{},
{},
{},
{},
{},
{},
{},
{},
]}
cell={[
// cell (0, 0) is read-only
{ row: 0, col: 0, readOnly: true },
]}
cells={(row, col) => {
// cell (2, 2) is editable
if (row === 2 && col === 2) {
return { readOnly: false, className: '' };
}
return {};
}}
/>
);
};
export default ExampleComponent;
TypeScript
import { FC } from 'react';
import { HotTable, HotTableProps } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import Handsontable from 'handsontable/base';
// register Handsontable's modules
registerAllModules();
const ExampleComponent: FC = () => {
const data: Handsontable.CellValue[][] = [
['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1', 'I1', 'J1'],
['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2', 'H2', 'I2', 'J2'],
['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3', 'H3', 'I3', 'J3'],
['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4', 'H4', 'I4', 'J4'],
['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5', 'H5', 'I5', 'J5'],
];
return (
<HotTable
data={data}
autoWrapRow={true}
autoWrapCol={true}
licenseKey="non-commercial-and-evaluation"
readOnly={true}
width="auto"
height="auto"
rowHeaders={true}
colHeaders={true}
columns={[
// each cell in the first (by physical index) column is editable
{ readOnly: false, className: '' },
{},
{},
{},
{},
{},
{},
{},
{},
{},
]}
cell={[
// cell (0, 0) is read-only
{ row: 0, col: 0, readOnly: true },
]}
cells={(row: number, col: number) => {
// cell (2, 2) is editable
if (row === 2 && col === 2) {
return { readOnly: false, className: '' };
}
return {};
}}
/>
);
};
export default ExampleComponent;

Non-Idempotent Options

A non-idempotent option is one that produces different results when applied multiple times. In the context of Handsontable and <HotTable/> component, options like manualColumnMove=[1, 0] will swap columns every time they’re applied - first application swaps columns, second application swaps them back, third swaps again, and so on.

Problem

Non-idempotent options like manualColumnMove and manualRowMove cause unwanted visual changes on every React re-render because they operate on visual indexes.

// Problem: Columns swap on EVERY re-render
const ExampleComponent = () => {
const [state, setState] = React.useState(0);
return (
<>
<button onClick={() => setState(state + 1)}>{state}</button>
<HotTable
manualColumnMove={[1, 0]} // Columns keep swapping!
data={[['A', 'B'], [0, 1]]}
licenseKey="non-commercial-and-evaluation"
/>
</>
);
};

Solution

Use initialState to apply these options only during initialization:

<HotTable
initialState={{
manualColumnMove: [1, 0] // Applied only once
}}
data={[['A', 'B'], [0, 1]]}
rowHeaders={true}
colHeaders={true}
licenseKey="non-commercial-and-evaluation"
/>

Configuration options

Core methods

Hooks

Result

Your grid now applies configuration options at the scope you specified — grid-wide, per column, per row, or per individual cell — using Handsontable’s cascading configuration system.